// C Source File
// Created 16/06/01; 13:32:35

// #define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files
#include "spr_skater.h"
short _ti89;                  // Produce .89Z File
unsigned char parcours[6];
unsigned char position;
unsigned char nextpos;
unsigned char vautre;
unsigned char dist;
unsigned char diff;
signed int saut;


void decale(void) // Dcale la liste du parcours
{
	int i;
	for (i=1;i<6;i++)
	{
		parcours[i-1] = parcours[i];
		if (parcours[i-1]>2) parcours[i-1]=0;
	}
	i=random(3);
	if ( i==1 && parcours[4]==1 ) i=0;
	parcours[5] = i;
}

void decors(int deb) // Affiche le parcours  partir de deb
{
	int i;
	int plan;
	for (i=deb;i<6;i++)
	{
		// Placer une voiture
		if (parcours[i]==1)
		{
			for (plan=0;plan<2;plan++)
			{
				Sprite32(32*(i-1),68,32,&voiture[plan][1],GetPlane(plan),SPRT_OR);
			}
		}
		// Placer une barre courte
		if (parcours[i]==2 && parcours[i-1]!=2 && parcours[i+1]!=2)
		{
			for (plan=0;plan<2;plan++)
			{
				Sprite32(32*(i-1),68,32,&barre[plan][1],GetPlane(plan),SPRT_OR);
			}
		}
		
		//Placer un dbut de barre
		if (parcours[i]==2 && parcours[i-1]!=2 && parcours[i+1]==2)
		{
			for (plan=0;plan<2;plan++)
			{
				Sprite32(32*(i-1),68,32,&barre1[plan][1],GetPlane(plan),SPRT_OR);
			}
		}
		
		//Placer un segment de barre
		if (parcours[i]==2 && parcours[i-1]==2 && parcours[i+1]==2)
		{
			for (plan=0;plan<2;plan++)
			{
				Sprite32(32*(i-1),68,32,&barre2[plan][1],GetPlane(plan),SPRT_OR);
			}
		}
		
		//Placer une fin de barre
		if (parcours[i]==2 && parcours[i-1]==2 && parcours[i+1]!=2)
		{
			for (plan=0;plan<2;plan++)
			{
				Sprite32(32*(i-1),68,32,&barre3[plan][1],GetPlane(plan),SPRT_OR);
			}
		}
	// Le dcors est en place !!!
	}
}

void perso(void) // Affiche le personnage en fonction de sa position
{
	int plan;
	if (position==0 || position > 4) position = 1;
	if (position==1)
	{
		for (plan=0;plan<2;plan++)
		{
			Sprite32(2,68,32,&pos1[plan][1],GetPlane(plan),SPRT_OR);
		}
	}
	if (position==2)
	{
		for (plan=0;plan<2;plan++)
		{
			Sprite32(2,38,32,&pos2[plan][1],GetPlane(plan),SPRT_OR);
		}
	}
	if (position==3)
	{
		for (plan=0;plan<2;plan++)
		{
			Sprite32(2,62,32,&pos3[plan][1],GetPlane(plan),SPRT_OR);
		}
	}
	if (position==4)
	{
		for (plan=0;plan<2;plan++)
		{
			Sprite32(2,68,32,&pos4[plan][1],GetPlane(plan),SPRT_OR);
		}
	}	
}

void anal_draw(void) // Analyse si chute
{
	if ((parcours[1]==2 && parcours[2]!=2) || (saut+1==dist))
	{
		nextpos=1;
	}
	else
	{
		nextpos=0;
	}
	if ((parcours[1]==1 && position!=2) || 
	(parcours[1]==2 && position==1) || 
	(parcours[1]==0 && position==3))
	{
		position = 4;
		vautre++;
	}
}
void clrgray() // Efface les deux crans (niveaux de gris)
{
	SetPlane(0);
	clrscr();
	SetPlane(1);
	clrscr();
}

void quit(void) // Quitter le jeu
{
	GrayMode(GRAY_OFF);
	clrscr();
	printf("Aie, 5 vautres!\n");
	printf("Distance %d",dist);
	ngetchx();
	vautre = 0;
	exit(0);
}

int touche(void) // Rcuprer le code de la dernire touche presse
{
	int key;
	void *kbq;
	kbq = kbd_queue();
	OSdequeue (&key, kbq);
	return key;
}

void SetPosition(void) // Analyser la touche et configurer la position en fonction
{
	int key;
	key = touche();
	if (key==KEY_UP && (saut+1)<dist) // Si Touche haut et joueur  terre, a fait 2 tapes que le joueur a saut
	{
		position = 2; // Position saut
		saut=dist; // Enregistre la position de dpart
	}
	if (key==KEY_APPS) position = 3; // Dbut de grind (la fin est automatique)
	if (key==KEY_ESC) quit();
	if (nextpos!=0) // Priorit si le joueur doit tomber
	{
		position=nextpos;
		nextpos=0;
	}
}
void wait(void) // Attendre selon la difficult
{
	OSFreeTimer(6);
	OSRegisterTimer(6, diff);
	while (!OSTimerExpired(6))
	{
		SetPosition();
	}
	OSFreeTimer(6);
}

void init(void) // Initialisation niveau de gris
{
	if (!GrayMode(GRAY_ON)) return;
	memset(GetPlane(0),0,LCD_SIZE);
	memset(GetPlane(1),0,LCD_SIZE);
	randomize();
}

void menu(void)
{
	int key;
	 //Prsentation
	clrscr();
	FontSetSys (F_8x10);
	printf("      Skater\n\n");
	printf("  www.ItHasU.fr.st\n");
	ngetchx();
	// Fin de la prsentation -- OK !
	clrscr();
	key = 0;
	while (key!=KEY_ENTER)
	{
		if (key==KEY_UP && diff<12) diff++;
		if (key==KEY_DOWN && diff>1) diff--;
		clrscr();
		FontSetSys (F_8x10);
		printf("Difficult :\n");
		FontSetSys (F_6x8);
		printf("Vitesse : %d\n",diff);
		if (diff<2) printf("Jsus is back");
		if (diff>=2 && diff<5) printf("Hardcore");
		if (diff>=5 && diff<8) printf("Salut Tony");
		if (diff>=8 && diff<10) printf("Newbie");
		if (diff>=10) printf("Fillette");
		key=ngetchx();
	}
}


// Main Function
void _main(void)
{
	int i;
	diff=8;
	menu();
	// Gnration d'une liste vide
	for (i=0;i<6;i++)
	{
		parcours[i]=0;
	}
	// Gnration -- OK !
	
	// Dfinition des variables de dpart
	position=1;
	vautre = 0;
	dist = 0;
	// Dfinition finie -- OK !
	
	clrscr(); // Efface l'cran
	init(); // Passe en niveaux de gris -- OK !
	while (vautre<5)
	{
		clrgray(); // Efface l'cran -- OK !
		decors(1); // Affiche les obstacles -- OK !
		perso(); // Affiche le skateur -- OK !
		anal_draw(); // Analyse des collisions -- OK !
		if (position==4) // Si vautr -- OK !
		{
			for (i=1;i<4;i++) // Dgage le chemin -- OK !
			{
				parcours[i]=0;
			}
			clrgray(); // Efface l'cran  -- OK !
			decors(2); // Graphique du joueur vautr -- OK !
			perso(); // Bis -- OK !
			ngetchx(); // Pause -- OK !
			position=1; // RAZ Joueur -- OK !
		}
		SetPosition(); // Rcupration des touches
		wait(); // Attendre un peu
		SetPosition(); // Rcupration des touches
		decale(); // Dcaler les obstacles et en insrer un nouveau alatoire
		dist++; // Incrmenter un au score
	}
	quit();
}
